
local MAJOR = "StarLibBignum-1.0" 
local MINOR = 1
assert(LibStub, MAJOR.." requires LibStub") 
local StarLibBignum = LibStub:NewLibrary(MAJOR, MINOR)
local LibError = LibStub("StarLibError-1.0")
assert(LibError, "StarLibBignum-1.0 requires StarLibError-1.0")
local LibProperty = LibStub("StarLibProperty-1.0")
assert(LibProperty, "StarLibBignum-1.0 requires StarLibProperty-1.0")
local LibTimer = LibStub("StarLibTimer-1.0")
assert(LibTimer, "StarLibBignum-1.0 requires StarLibTimer-1.0")

local pool = setmetatable({}, {__mode = "k"})

if not StarLibBignum then return end

local numMap

if not StarLibBignum.__index then
	StarLibBignum.__index = StarLibBignum
end

function StarLibBignum:New(visitor, env, context, errorLevel) 
	assert(context, "Please provide the bignum with a context")
	assert(context.name, "Please provide the bignum with a name")
	assert(context.string, context.name .. ": Please provide the bignum with a string")
	assert(env, context.name .. ": Please provide the bignum with an environment")
	
	local obj = next(pool)

	if obj then
		pool[obj] = nil
	else
		obj = {}
	end

	obj.errorLevel = errorLevel
	
	obj.error = LibError:New(errorLevel)
	
	setmetatable(obj, self)
	
	obj.value = LibProperty:New(env, context.name .. " string", context.string, "", errorLevel)
	
	obj.update = context.update or 500
	
	obj.timer = LibTimer:New(self.update, true, obj.Update, obj, errorLevel)
	
	obj.visitor = visitor
	
	return obj	
end

function StarLibBignum:Del(ev)
	if self == StarLibBignum then
		LibProperty.pool[ev] = true
	else
		LibProperty.pool[self] = true
	end
end

function StarLibBignum:Start()
	self.timer:Start()
end

function StarLibBignum:Stop()
	self.timer:Stop()
end

function StarLibBignum:Update()

end

smallNumMap = {
	{ --/* 0 */
		" _ ",
		"| |",
		"|_|",
		"   " },
	{ --/* 1 */
		"   ",
		"  |",
		"  |",
		"   " },
	{ --/* 2 */
		" _ ",
		" _|",
		"|_ ",
		"   " },
	{ --/* 3 */
		" _ ",
		" _|",
		" _|",
		"   " },
	{ --/* 4 */
		"   ",
		"|_|",
		"  |",
		"   " },
	{ --/* 5 */
		" _ ",
		"|_ ",
		" _|",
		"   " },
	{ --/* 6 */
		" _ ",
		"|_ ",
		"|_|",
		"   " },
	{ --/* 7 */
		" _ ",
		"  |",
		"  |",
		"   " },
	{ --/* 8 */
		" _ ",
		"|_|",
		"|_|",
		"   " },
	{ --/* 9 */
		" _ ",
		"|_|",
		" _|",
		"   " },
	{ --/* colon */
		" ",
		".",
		".",
		" " }
	}
	
